flink-issues mailing list archives

Site index · List index
Message view « Date » · « Thread »
Top « Date » · « Thread »
From GitBox <...@apache.org>
Subject [GitHub] walterddr commented on a change in pull request #7263: [FLINK-11081] Support binding port range for REST server
Date Tue, 11 Dec 2018 17:25:39 GMT
walterddr commented on a change in pull request #7263: [FLINK-11081] Support binding port range
for REST server
URL: https://github.com/apache/flink/pull/7263#discussion_r240706051
 
 

 ##########
 File path: flink-runtime/src/main/java/org/apache/flink/runtime/rest/RestServerEndpoint.java
 ##########
 @@ -181,14 +184,44 @@ protected void initChannel(SocketChannel ch) {
 				.channel(NioServerSocketChannel.class)
 				.childHandler(initializer);
 
-			log.debug("Binding rest endpoint to {}:{}.", restBindAddress, restBindPort);
-			final ChannelFuture channel;
-			if (restBindAddress == null) {
-				channel = bootstrap.bind(restBindPort);
-			} else {
-				channel = bootstrap.bind(restBindAddress, restBindPort);
+			ChannelFuture channel;
+
+			// parse port range definition and create port iterator
+			Iterator<Integer> portsIterator;
+			try {
+				portsIterator = NetUtils.getPortRangeFromString(restBindPort);
+			} catch (Exception e) {
+				throw new IllegalArgumentException("Invalid port range definition: " + restBindPort);
+			}
+
+			int chosenPort = 0;
+			while (portsIterator.hasNext()) {
+				try {
+					chosenPort = portsIterator.next();
+					if (restBindAddress == null) {
+						channel = bootstrap.bind(chosenPort);
+					} else {
+						channel = bootstrap.bind(restBindAddress, chosenPort);
+					}
+					serverChannel = channel.syncUninterruptibly().channel();
+					break;
+				} catch (Exception e) {
+					// we can continue to try if this contains a netty channel exception
+					Throwable cause = e.getCause();
+					if (!(cause instanceof org.jboss.netty.channel.ChannelException ||
+						cause instanceof java.net.BindException)) {
+						throw e;
 
 Review comment:
   doesn't this actually throws the exception to top level instead of "continue to try"? also
since 
   `chosenPort = portsIterator.next();` always gets call, how can retry over the same port
here?

----------------------------------------------------------------
This is an automated message from the Apache Git Service.
To respond to the message, please log on GitHub and use the
URL above to go to the specific comment.
 
For queries about this service, please contact Infrastructure at:
users@infra.apache.org


With regards,
Apache Git Services

Mime
View raw message